# BGP Peer

Check plugin to monitors status of BGP peers and inventory plugin for static BGP peer data.

**NOTE**: This check was originally written by Thomas Wollner (tw[at]wollner-net[dot]de). I have rewritten this plugin for CMK 2.0 and extended it to be the base for all my other BGP plugins.

**NOTE**: this check is the base for the [Arista](https://thl-cmk.hopto.org/gitlab/checkmk/arista_networks/arista_bgp_peer), [Cisco](https://thl-cmk.hopto.org/gitlab/checkmk/cisco/cisco_bgp_peer), [Huawei](https://thl-cmk.hopto.org/gitlab/checkmk/huawei/huawei_bgp_peers) and [Juniper](https://thl-cmk.hopto.org/gitlab/checkmk/juniper-networks/juniper_bgp_peer) BGP peer addons.

---
### Check Info

* *service*: creates the service **BGP Peer** with the ip-address of the peer as item. Depending on the addon the address family and the VRF/VR/Remote AS will also be used in the item. Except for the remote peer address this is configurable.

* *state*:\
    **critical**: if Peer state is idle or if accepted_prefixes >= prefix_admin_limit\
    **warning**: if Peer state is not idle or not established, if accepted_prefixes >= warn_threshold, if Admin state is not admin start\
    **critical**/**warning**: if Peer uptime below the configured levels\
    **critical**: if Peer not found in SNMP data
    
* *wato*: [see WATO options](/doc/wato.png?raw=true "WATO options")

* *perfdata (if avilable)*: 
    * in/out updates (/s)
    * in/out messages (/s)
    * Peer uptime (s)
    * Last update recived (/s)
    * FMS Transitions (count)

---
### Download

* [bgp_peer.mkp (latest version)](https://thl-cmk.hopto.org/gitlab/checkmk/vendor-independent/bgp_peer/-/raw/2.1.x/bgp_peer.mkp "Download latest version")

---                   
### Installation

You can install the package by uploading it to your CheckMK site and as site user run `mkp install bgp_peer.mkp`.


In the Enterprise/Free edition of CheckMK you can use the GUI to install the package (_Setup_ -> _Extension Packages_ -> _Upload package_)

---
### Want to contribute?

Nice ;-) Have a look at the [contribution guidelines](CONTRIBUTING.md "Contributing")

---
### Sample output

<details><summary>Sample output</summary>
![sample output](/doc/sample.png?raw=true "sample output")
</details>

<details><summary>Sample inventory output</summary>
![sample inventory output](/doc/sample-inventory.png?raw=true "sample inventory output")
</details>

<details><summary>WATO options (check)</summary>
![WATO options (check)](/doc/wato.png?raw=true "WATO options (check)")
</details>

<details><summary>WATO options (discovery)</summary>
![WATO options (discovery)](/doc/wato-discovery.png?raw=true "WATO options (discovery)")
</details>

<details><summary>WATO options (inventory)</summary>
![WATO options](/doc/wato-inventory.png?raw=true "WATO options (inventory)")
</details>
